## RmlUi Sample Applications

This directory contains a collection of sample applications that demonstrate the use of RmlUi in small, easy to understand applications.

### Directory Overview

#### `assets`

This directory contains the assets shared by all the sample applications.

#### `basic`

This directory contains basic applications that demonstrate initialisation, usage, shutdown and installation of custom interfaces.
 
-  `animation` animations and transitions
-  `benchmark` a benchmark to measure performance
-  `bitmapfont` using a custom font engine
-  `customlog` setting up custom logging
-  `databinding` setting up and using data bindings
-  `demo` demonstrates a variety of features in RmlUi and includes a sandbox for playing with RML/RCSS
-  `drag` dragging elements between containers
-  `loaddocument` loading your first document
-  `lottie` playing Lottie animations, only enabled with the [Lottie plugin](https://mikke89.github.io/RmlUiDoc/pages/cpp_manual/lottie.html)
-  `sdl2` integrating with SDL2
-  `sfml2` integrating with SFML2
-  `svg` render SVG images, only enabled with the [SVG plugin](https://mikke89.github.io/RmlUiDoc/pages/cpp_manual/svg.html)
-  `transform` demonstration of transforms
-  `treeview` using data bindings to create a file browser
               
#### `invaders`

A full implementation of the 1970s classic Space Invaders using the RmlUi interface.
               
#### `luainvaders`

Lua version of the invaders sample. Only installed with the Lua plugin.
               
#### `shell`

Common platform specific code used by all the samples for open windows, processing input and access files. Supports Windows, macOS and Linux.
               
#### `tutorial`

Tutorial code that should be used in conjunction with the tutorials in the [RmlUi documentation](https://mikke89.github.io/RmlUiDoc/).
